#!/usr/bin/perl

### ----------------------------------------------- ###
#  fields.pl
#  -----------
#
#  input: fields.txt
#
#  input format: 
#  (seg_code<tab>lfd_nr<tab>data_item<tab>description<tab>
#   data_structure<tab>req_opt<tab>repetitional<tab>table_id<cr>)+
#
#  output: fields.dtd
#
#
#  (last revised August 11, 1999)
### ----------------------------------------------- ###

open (infile, "fields.txt");
open (outfile, ">fields.dtd");

while ($line = <infile>) {

  # parse components
  $line =~ s/\"//g;
  chop($line);
  @row = split(/\t/,$line);
  $seg = @row[0];
  $seq = @row[1];
  $item = @row[2];
  $name = @row[3];
  $dt = @row[4];
  $opt = @row[5];
  $rep = @row[6];
  $table = @row[7];

  $seq =~ s/^0+//;
  $name =~ s/\&/&amp;/g;
  $name =~ s/\'/&apos;/g;
  $dt =~ s/\+/\_/g;
  $element = $seg.".".$seq;

  print outfile "<!ENTITY % $element.CONTENT \"%$dt;\">\n";
  print outfile "<!ELEMENT $element %$element.CONTENT;>\n";
  print outfile "<!ENTITY % $element.ATTRIBUTES\n  \"Item CDATA #FIXED \'$item\'\n  Table CDATA #FIXED \'$table\'\n  LongName CDATA #FIXED \'$name\'\n  Type CDATA #FIXED \'$dt\'\">\n";
  print outfile "<!ATTLIST $element  %$element.ATTRIBUTES;>\n";
} 

# close files
close (infile);
close (outfile);

