#!/usr/bin/perl

### ----------------------------------------------- ###
#  segments.pl
#  -----------
#
#  input: fields.txt
#
#  input format: 
#  (seg_code<tab>lfd_nr<tab>data_item<tab>description<tab>
#   data_structure<tab>req_opt<tab>repetitional<tab>table_id<cr>)+
#
#  output: segments.dtd
#
#
#  (last revised July 27, 1999)
### ----------------------------------------------- ###

open (infile, "fields.txt");
open (outfile, ">segments.dtd");

  $oldseg = "";
  $definition = "";

while ($line = <infile>) {
  $char = "";
  chop($line);

  # parse components
  $line =~ s/\"//g;
  @row = split(/\t/,$line);
  $seg = @row[0];
  $seq = @row[1];
  $item = @row[2];
  $name = @row[3];
  $dt = @row[4];
  $opt = @row[5];
  $rep = @row[6];
  $table = @row[7];

  $seq =~ s/^0+//;
  $element = $seg.".".$seq;

  if ($seg ne $oldseg) {
    $definition =~ s/^\,//;
    if ($oldseg ne "") {
      print outfile "<!ENTITY % $oldseg.CONTENT \"($definition)\">\n";
      print outfile "<!ELEMENT $oldseg %$oldseg.CONTENT;>\n\n";}
    $oldseg = $seg;
    $definition = "";
    }


  if (
        (
           ($opt eq "(B) R") ||
           ($opt eq "R")
        )
     && 
        (
           ($rep eq "N") ||
           ($rep eq "")
        )
     ) {$char = ""}


  if (
        (
           ($opt eq "B") ||
           ($opt eq "C") ||
           ($opt eq "O") ||
           ($opt eq "X") ||
           ($opt eq "Y") ||
           ($opt eq "")
        )
     && 
        (
           ($rep eq "N") ||
           ($rep eq "")
        )
     ) {$char = "?"}


  if (
        (
           ($opt eq "(B) R") ||
           ($opt eq "R")
        )
     && 
        (
           ($rep eq "Y")
        )
     ) {$char = "+"}


  if (
        (
           ($opt eq "B") ||
           ($opt eq "C") ||
           ($opt eq "O") ||
           ($opt eq "X") ||
           ($opt eq "Y") ||
           ($opt eq "")
        )
     && 
        (
           ($rep eq "Y")
        )
     ) {$char = "*"}


  if (($char eq "+") || ($char eq "*")) {
    print outfile "<!ENTITY % $element.LST.CONTENT \"($element)+\">\n";
    print outfile "<!ELEMENT $element.LST %$element.LST.CONTENT;>\n";
    $definition .= ",$element.LST";
    if ($char eq "*") {$definition .= "?"}
    } 
  else {
    $definition .= ",$element$char";
    }
  } 

# close files
close (infile);
close (outfile);

